Lotus and Horticulture HDU - 6012

 1 #include <iostream>
 2 using namespace std;
 3 #include<string.h>
 4 #include<set>
 5 #include<stdio.h>
 6 #include<math.h>
 7 #include<queue>
 8 #include<map>
 9 #include<algorithm>
10 #include<queue>
11 #define ll long long
12 int t,n,l,r,d,b,c;
13 struct lll
14 {
15     int wendu,chazhi;
16     bool operator<(const lll &qwe)const
17     {
18         return wendu<qwe.wendu;
19     }
20 }a[100100];
21
22 int main()
23 {
24     scanf("%d",&t);
25     while(t--)
26     {
27         scanf("%d",&n);
28         long long max1=0,sum=0;int add=0;
29         for(int i=1;i<=n;++i)
30         {
31             scanf("%d%d%d%d%d",&l,&r,&d,&b,&c);
32             sum+=c;
33             a[++add].wendu=l*2;
34             a[add].chazhi=d-c;
35             a[++add].wendu=r*2+1;
36             a[add].chazhi=b-d;
37         }
38         max1=sum;
39         sort(a+1,a+1+add);
40         int i;
41         for(i=1;i<=add;)
42         {
43           sum+=a[i].chazhi;
44           i++;
45           while(a[i].wendu==a[i-1].wendu)
46             {
47                 sum+=a[i].chazhi;
48                 i++;
49             }
50           max1=max(max1,sum);
51         }
52        cout<<max1<<endl;
53     }
54 }

These days Lotus is interested in cultivating potted plants, so she wants to build a greenhouse to meet her research desires.

Lotus placed all of the nn pots in the new greenhouse, so all potted plants were in the same environment.

Each plant has an optimal growth temperature range of [l,r][l,r], which grows best at this temperature range, but does not necessarily provide the best research value (Lotus thinks that researching poorly developed potted plants are also of great research value).

Lotus has carried out a number of experiments and found that if the growth temperature of the i-th plant is suitable, it can provide aiai units of research value; if the growth temperature exceeds the upper limit of the suitable temperature, it can provide the bibi units of research value; temperatures below the lower limit of the appropriate temperature, can provide cici units of research value.

Now, through experimentation, Lotus has known the appropriate growth temperature range for each plant, and the values of aa, bb, cc are also known. You need to choose a temperature for the greenhouse based on these information, providing Lotus with the maximum research value.

__NOTICE: the temperature can be any real number.__

InputThe input includes multiple test cases. The first line contains a single integer TT, the number of test cases.

The first line of each test case contains a single integer n∈[1,50000]n∈[1,50000], the number of potted plants.

The next nn line, each line contains five integers li,ri,ai,bi,ci∈[1,109]li,ri,ai,bi,ci∈[1,109]. 
OutputFor each test case, print one line of one single integer presenting the answer. 
Sample Input

1
5
5 8 16 20 12
10 16 3 13 13
8 11 13 1 11
7 9 6 17 5
2 11 20 8 5

Sample Output

83超时的一天  看了别人的才写出来
时间: 2024-10-08 08:49:15

Lotus and Horticulture HDU - 6012的相关文章

HDU 6012 Lotus and Horticulture

Lotus and Horticulture 题意:花有一个最适的温度范围 l 和 r ,如果等于这个范围其价值为a, 高于为b,等于为c,求最大的价值 思路:如果一一枚举肯定超时,所有把每个区间的端点都存在一个结构体里,-1为左, 1为右,再从小到大排序,假设起点从负无穷小开始(sum = 所有的c),一一遍历每个端点,求出最大值. #include <iostream> #include <queue> #include <cstdio> #include <

BestCoder Round #91 1002 Lotus and Horticulture

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6012 题意: 这几天Lotus对培养盆栽很感兴趣,于是她想搭建一个温室来满足她的研究欲望. Lotus将所有的nn株盆栽都放在新建的温室里,所以所有盆栽都处于完全相同的环境中. 每一株盆栽都有一个最佳生长温度区间[l,r][l,r],在这个范围的温度下生长会生长得最好,但是不一定会提供最佳的研究价值(Lotus认为研究发育不良的盆栽也是很有研究价值的). Lotus进行了若干次试验,发现若第ii株盆

hdu 6011 Lotus and Characters

BC的A题 不过被疯狂hack 因为有的人一开始认为只需要计算所有正权值 包括我也是 不过写一下就知道了 就算有负权 仍然可能对ans有贡献 比赛时候的代码可能是改的太匆忙了 到底还是被hack了…… 还好B题留到最后了了 要不BC就血崩了…… 1 #include<bits/stdc++.h> 2 #define cl(a,b) memset(a,b,sizeof(a)) 3 #define debug(x) cerr<<#x<<"=="<&

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name